#!/bin/bash

# Created on: 2017.7.27

#Set this to be real install patch.
INSTALL_PATH="/"

INSTALL_ROOT_DIR="Vernox"
INSTALL_LOCATION=${INSTALL_PATH}${INSTALL_ROOT_DIR}

DBFILE=${INSTALL_LOCATION}"/Data/Vernox"

isSystemd=true

get_user_input()
{
	echo "WARNING!!!"
	echo "Uninstall will delete all your database files, please make sure you want continue?"
	echo "Input 'yes' to uninstall VERNOX, other to quit."

	read CONFIRM

	CONFIRM=$(echo ${CONFIRM} | tr [a-z] [A-Z])

	if [ ${CONFIRM} != "YES" ]
	then
		exit
	fi
}

check_systemd()
{
	tmp=`systemctl --version` 1>&2 2>/dev/null
	if [ $? == 127 ]
	then
		isSystemd=false
	fi
}

uninstall_services()
{
	if [ $isSystemd == true ]
	then
		if [ -e /etc/init.d/vernoxservice -a -e /etc/init.d/vernoxstorage -a -e /etc/systemd/system/vernoxservice.service -a -e /etc/systemd/system/vernoxstorage.service ]
		then
			systemctl stop vernoxservice.service
			systemctl stop vernoxstorage.service
			systemctl disable vernoxservice.service 1>&2 2>/dev/null
			systemctl disable vernoxstorage.service 1>&2 2>/dev/null
			rm -rf /etc/init.d/vernoxservice
			rm -rf /etc/init.d/vernoxstorage
			rm -rf /etc/systemd/system/vernoxservice.service
			rm -rf /etc/systemd/system/vernoxstorage.service
		else
			echo "VERNOX did not installed."
			exit
		fi
	else
		if [ "$(chkconfig --list | grep vernoxservice)""X" == "X" -a "$(chkconfig --list | grep vernoxstorage)""X" == "X" ]
		then
			echo "VERNOX did not installed."
			exit
		else
			service vernoxservice stop
			service vernoxstorage stop
			chkconfig vernoxservice off
			chkconfig vernoxstorage off
			chkconfig --del vernoxservice
			chkconfig --del vernoxstorage
			rm -rf /etc/init.d/vernoxservice
			rm -rf /etc/init.d/vernoxstorage
		fi
	fi
}

unintall_databases_file()
{
	if [ -e $DBFILE ]
	then
		rm -rf $DBFILE
		if [ $? -eq 0 ]
		then
			echo "Delete VERNOX success!"
		fi
	else
		echo "VERNOX is not exsist."
	fi
}

uninstall_ipc_objects()
{
	#Trace
	ipcrm -M 0x53425452
	if [ $? -eq 0 ]
	then
		echo "remove key(0x53425452) success!"
	fi

	#Log
	ipcrm -M 0x53424C4F
	if [ $? = 0 ]
	then
		echo "remove key(0x53424C4F) success!"
	fi

	#STORAGEMEMFILE
	ipcrm -M 0x5342534D
	if [ $? -eq 0 ]
	then
		echo "remove key(0x5342534D) success!"
	fi

	#ROLLBACKMEM
	ipcrm -M 0x5342524D
	if [ $? -eq 0 ]
	then
		echo "remove key(0x5342524D) success!"
	fi

	#SystemDataFile
	ipcrm -M 0x53424601
	if [ $? -eq 0 ]
	then
		echo "remove key(0x53424601) success!"
	fi

	#DataFile
	ipcrm -M 0x53424602
	if [ $? -eq 0 ]
	then
		echo "remove key(0x53424602) success!"
	fi

	#TreeFile
	ipcrm -M 0x53424603
	if [ $? -eq 0 ]
	then
		echo "remove key(0x53424603) success!"
	fi

	#HashFile
	ipcrm -M 0x53424604
	if [ $? -eq 0 ]
	then
		echo "remove key(0x53424604) success!"
	fi
	
	#CashBuffer
	ipcrm -M 0x53424342
	if [ $? -eq 0 ]
	then
		echo "remove key(0x53424342) success!"
	fi
}

#uninstall sequences
get_user_input
check_systemd
uninstall_services
unintall_databases_file
uninstall_ipc_objects
